Bug 914996 - Review Request: gitstats - Generates statistics based on GIT repository activity
Review Request: gitstats - Generates statistics based on GIT repository activity
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Pavel Raiskup
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-02-23 17:59 EST by Stephen Gordon
Modified: 2013-03-24 14:02 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-03-12 04:33:13 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
praiskup: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Stephen Gordon 2013-02-23 17:59:54 EST
Spec URL: http://fedorapeople.org/~sgordon/gitstats.spec
SRPM URL: http://fedorapeople.org/~sgordon/gitstats-0.1-20130223gitaa77a89.fc18.src.rpm
Description:

GitStats is a statistics generator for git (a distributed revision control system) repositories. It examines the repository and produces some interesting  
statistics from the history of it. Currently HTML is the only output format.

Fedora Account System Username: sgordon
Comment 1 Stephen Gordon 2013-02-23 18:08:41 EST
$ rpmlint gitstats.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint gitstats-0.1-20130223gitaa77a89.fc18.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint gitstats-0.1-20130223gitaa77a89.fc18.noarch.rpm 
gitstats.noarch: W: no-manual-page-for-binary gitstats
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
Comment 2 Stephen Gordon 2013-02-23 18:22:14 EST
NB: When reviewing the sources to determine the license I found that while the documentation files shipped by upstream list GPLv2 and GPLv3 one of the files is licensed under the MIT license.

I have raised a ticket with upstream to address this omission in the licenses file and noted all three licenses in the spec file:

    https://github.com/hoxu/gitstats/issues/13
Comment 3 Stephen Gordon 2013-02-23 18:25:27 EST
Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5048859
Comment 4 Stephen Gordon 2013-02-24 17:38:12 EST
(In reply to comment #2)
>     https://github.com/hoxu/gitstats/issues/13

Upstream have already updated to resolve this so I've updated the SPEC and SRPM to pick this up. I also realized that there is .pod file provided which can be used to generate the man page so that is now also included.

Spec URL: http://fedorapeople.org/~sgordon/gitstats-0.2.spec
SRPM URL: http://fedorapeople.org/~sgordon/gitstats-0.2-20130224git0843039.fc18.src.rpm

$ rpmlint gitstats.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.
   
$ rpmlint gitstats-0.2-20130224git0843039.fc18.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint gitstats-0.2-20130224git0843039.fc18.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Scratch Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5051056
Comment 5 Pavel Raiskup 2013-02-25 02:06:01 EST
Thanks for packaging, I'll look at this review.
Comment 6 Pavel Raiskup 2013-02-25 03:37:01 EST
Hi Stephenm, here is my first comment iteration :)

=======

1. bad spec naming?

> Upstream have already updated to resolve this so I've updated the SPEC and
> SRPM to pick this up. I also realized that there is .pod file provided which
> can be used to generate the man page so that is now also included.
>
> Spec URL: http://fedorapeople.org/~sgordon/gitstats-0.2.spec
> SRPM URL: http://fedorapeople.org/~sgordon/gitstats-0.2-20130224git0843039.fc18.src.rpm

Why do you now call the spec file gitstats-0.2.spec and not gitstats.spec?  Your
first specfile was called gitstats.spec..

2. unnecessary %attr() macros

> $ cat *.spec
> [...]
> %files
> %attr(755, root, root) %{_bindir}/%{name}
  ^^^^^^^^^^^^^^^^^^^^^^ none of these should be needed

3. Missing release number

> Release:    %{checkout}%{?dist}

I think that even the first release number should be specified.  Partly because
I (as a reviewer) can see, where it will be finally placed and because of this
also:

  $ rpmdev-vercmp gitstats-0.2-20130224git0843039 gitstats-0.2-1.20130224git0843039
  gitstats-0.2-20130224git0843039 > gitstats-0.2-1.20130224git0843039

4. (nit: I would create one-newline separator between changelog entries)

5. Gzip inside BuildRequires is redundant .. it must be installed on minimum
   build system.

Pavel
Comment 7 Stephen Gordon 2013-02-25 08:10:12 EST
(In reply to comment #6)
> Hi Stephenm, here is my first comment iteration :)
> 
> =======
> 
> 1. bad spec naming?
> 
> > Upstream have already updated to resolve this so I've updated the SPEC and
> > SRPM to pick this up. I also realized that there is .pod file provided which
> > can be used to generate the man page so that is now also included.
> >
> > Spec URL: http://fedorapeople.org/~sgordon/gitstats-0.2.spec
> > SRPM URL: http://fedorapeople.org/~sgordon/gitstats-0.2-20130224git0843039.fc18.src.rpm
> 
> Why do you now call the spec file gitstats-0.2.spec and not gitstats.spec? 
> Your
> first specfile was called gitstats.spec..

I've actually had reviewers request that I do that in the past so they can see the differences between the submitted files (rather than overwriting each time).

> 2. unnecessary %attr() macros
> 
> > $ cat *.spec
> > [...]
> > %files
> > %attr(755, root, root) %{_bindir}/%{name}
>   ^^^^^^^^^^^^^^^^^^^^^^ none of these should be needed

Removed.

> 3. Missing release number
> 
> > Release:    %{checkout}%{?dist}
> 
> I think that even the first release number should be specified.  Partly
> because
> I (as a reviewer) can see, where it will be finally placed and because of
> this
> also:
> 
>   $ rpmdev-vercmp gitstats-0.2-20130224git0843039
> gitstats-0.2-1.20130224git0843039
>   gitstats-0.2-20130224git0843039 > gitstats-0.2-1.20130224git0843039

I went back and reviewed the naming/versioning guidelines and have ended up with names of the form gitstats-0-0.3.20130224git0843039. I reset the version to 0 as this is effectively "pre-release software" (no formal releases) and use the revision number to maintain the ordering as shown in the example:

http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Pre-Release_packages

> 4. (nit: I would create one-newline separator between changelog entries)

Done
 
> 5. Gzip inside BuildRequires is redundant .. it must be installed on minimum
>    build system.

Removed

> Pavel

Thanks Pavel, updated files are here:

Spec URL: http://fedorapeople.org/~sgordon/gitstats.spec
SRPM URL: http://fedorapeople.org/~sgordon/gitstats-0-0.3.20130224git0843039.fc18.src.rpm
Comment 8 Pavel Raiskup 2013-02-25 09:48:58 EST
>> Why do you now call the spec file gitstats-0.2.spec and not gitstats.spec?
>> Your
>> first specfile was called gitstats.spec..
>
> I've actually had reviewers request that I do that in the past so they can
> see the differences between the submitted files (rather than overwriting
> each time).

This is off-topic, but the git (cgit) is able to do this for you - you are able
to post everytime the same link to spec file and the history is not lost.

>> 3. Missing release number
>>
>>[..]
>
> I went back and reviewed the naming/versioning guidelines and have ended up
> with names of the form gitstats-0-0.3.20130224git0843039. I reset the
> version to 0 as this is effectively "pre-release software" (no formal
> releases) and use the revision number to maintain the ordering as shown in
> the example:
>
> http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Pre-Release_packages

Nice!  Thanks for this fix.  I missed that the 0.2 was not upstream version.
The N-V-R as you are using now is OK.

===============================================================================

Another problems:

1. package should own all directories it creates

   $ rpm -qf /usr/share/gitstats
   file /usr/share/gitstats is not owned by any package

   + %dir {_datarootdir}/%{name} probably should be added

2. Packages should try to preserve timestamps of original installed files

   s/install/install -p/

Otherwise it seems to be ok to me.  I'll re-run the fedora-review script and
post deep info when these are fixed.

Thanks for your work!
Pavel
Comment 9 Stephen Gordon 2013-02-25 19:31:30 EST
Spec URL: http://fedorapeople.org/~sgordon/gitstats.spec
SRPM URL: http://fedorapeople.org/~sgordon/gitstats-0-0.4.20130224git0843039.fc18.src.rpm

* Mon Feb 25 2013 Stephen Gordon <sgordon@redhat.com> 0-0.4-20130224git0843039  
- Added /usr/share/gitstats to files list.                                      
- Added -p argument to install invocation to preserve timestamps.               
- Use release macro in pod2man arguments instead of rebuilding the equivalent   
  again using the other macros.
Comment 10 Pavel Raiskup 2013-02-26 03:04:13 EST
Hi Stephen, one simple fix in changelog should be done:

-* Mon Feb 25 2013 Stephen Gordon <sgordon@redhat.com> 0-0.4-20130224git0843039
+* Mon Feb 25 2013 Stephen Gordon <sgordon@redhat.com> 0-0.4.20130224git0843039
                                              HERE  --------^

Sorry I didn't mention it before, I thought it was a bug in rpmlint but I was
just blind.  Please fix it before pushing to git.

APPROVED

===============================================================================
===============================================================================

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
See: http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#ValidLicenseShortNames


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[!]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[-]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 61440 bytes in 5 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: gitstats-0-0.4.20130224git0843039.fc19.src.rpm
          gitstats-0-0.4.20130224git0843039.fc19.noarch.rpm
gitstats.noarch: W: incoherent-version-in-changelog 0-0.4-20130224git0843039
['0-0.4.20130224git0843039.fc19', '0-0.4.20130224git0843039']
2 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint gitstats
gitstats.noarch: W: incoherent-version-in-changelog 0-0.4-20130224git0843039
['0-0.4.20130224git0843039.fc19', '0-0.4.20130224git0843039']
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'


Requires
--------
gitstats-0-0.4.20130224git0843039.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/env
    git >= 1.5.2.4
    gnuplot >= 4.0.0
    python >= 2.4.4



Provides
--------
gitstats-0-0.4.20130224git0843039.fc19.noarch.rpm:
    
    gitstats = 0-0.4.20130224git0843039.fc19



MD5-sum check
-------------
https://github.com/hoxu/gitstats/archive/084303928c4476cf50b3f33ac56a81d1113369f9/gitstats-084303928c4476cf50b3f33ac56a81d1113369f9.tar.gz :
  CHECKSUM(SHA256) this package     : e36e15385496b721e5bb53594cb61dd42f792e56a914cb4fda7bcef24c2f7ff2
  CHECKSUM(SHA256) upstream package : e36e15385496b721e5bb53594cb61dd42f792e56a914cb4fda7bcef24c2f7ff2


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -v -b 914996
Comment 11 Stephen Gordon 2013-02-27 09:59:59 EST
New Package SCM Request
=======================
Package Name: gitstats
Short Description: Generates statistics based on GIT repository activity
Owners: sgordon
Branches: f17 f18 el6
InitialCC:
Comment 12 Gwyn Ciesla 2013-02-27 10:08:06 EST
Git done (by process-git-requests).
Comment 13 Fedora Update System 2013-02-27 22:20:45 EST
gitstats-0-0.4.20130224git0843039.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/gitstats-0-0.4.20130224git0843039.el6
Comment 14 Fedora Update System 2013-02-27 22:22:10 EST
gitstats-0-0.4.20130224git0843039.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/gitstats-0-0.4.20130224git0843039.fc17
Comment 15 Fedora Update System 2013-02-27 22:23:31 EST
gitstats-0-0.4.20130224git0843039.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/gitstats-0-0.4.20130224git0843039.fc18
Comment 16 Fedora Update System 2013-03-02 14:54:48 EST
gitstats-0-0.4.20130224git0843039.fc17 has been pushed to the Fedora 17 testing repository.
Comment 17 Fedora Update System 2013-03-12 04:33:15 EDT
gitstats-0-0.4.20130224git0843039.fc17 has been pushed to the Fedora 17 stable repository.
Comment 18 Fedora Update System 2013-03-12 04:39:43 EDT
gitstats-0-0.4.20130224git0843039.fc18 has been pushed to the Fedora 18 stable repository.
Comment 19 Fedora Update System 2013-03-24 14:02:52 EDT
gitstats-0-0.4.20130224git0843039.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.